#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <unistd.h>
#include "common.h"
#include "dopage.h"
#include "mime.h"

const char *e404 = "HTTP/1.1 404 Not Found\nConnection: close\nContent-Type: text/html\n\n<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\n<HTML><HEAD>\n<TITLE>404 Not Found</TITLE>\n</HEAD><BODY>\n<H1>Not Found</H1>\nAin't none o' that 'round here!\n</BODY></HTML>\n";
const char *e403 = "HTTP/1.1 403 Not Found\nConnection: close\nContent-Type: text/html\n\n<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\n<HTML><HEAD>\n<TITLE>403 Access denied.</TITLE>\n</HEAD><BODY>\n<H1>Denied.</H1>\nYou are not worthy of this file.</BODY></HTML>\n";

int dooops(int sock, int err)
{
	switch (err){
		case ENOENT:
			write(sock, e404, strlen(e404));
			break;
		case EPERM:
		case EACCES:
			write(sock, e403, strlen(e403));
			break;
		default:
			printf("Unknown error: %d\n", err);
			perror("Unknown");
		}
	return FALSE;
}

bool
page_dump (int socket, char *filename)
{
  int fp, n;
  unsigned char buf[BUFSIZ];

  if((fp = open (filename, O_RDONLY)) == -1)
    return dooops(socket, errno);

  mime_announce(socket,filename);
  while ((n = read (fp, buf, BUFSIZ)) != 0)
    if(write (socket, buf, n) != n)
		printf("Failure writing %d bytes\n",n);

  close (fp);
  return FALSE;
}
