#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pthread.h>

#include "docgi.h"
#include "dopage.h"

unsigned int    s;
static unsigned int table[1024];

void
terminate(int signal)
{
	printf("Exiting on signal %d\n",signal);
	printf("%d\n", close(s));
	exit(EXIT_SUCCESS);
}

void
pipebomb(int signal)
{
	printf("um, pipebomb with signal %d\n", signal);
}

void            oops(char *str) {
	perror(str);
	exit(EXIT_FAILURE);
}

void  *
doserve(void *vals)
{
	char            trash[BUFSIZ], file[BUFSIZ], buf[BUFSIZ];
	int newsock, num;
	newsock = (int) *(int *)vals;
	num = (int) *((int *)vals + sizeof(int));
	
	memset(trash, 0, BUFSIZ);
	memset(file, 0, BUFSIZ);
	read(newsock, buf, BUFSIZ);
	sscanf(buf, "%s %s", file, trash);
	if (trash[strlen(trash) - 1] == '/')
		sprintf(trash, "%sindex.html", trash);

	sprintf(file, "%s/public_html%s", getenv("HOME"), trash);

	write(newsock, "HTTP/1.1 200 OK\n", strlen("HTTP/1.1 200 OK "));
	write(newsock, "Connection: close\n", strlen("Connection: close "));

	strcpy(trash, file);
	if (cgi_check(trash))
		cgi_exec(newsock, file);
	else
		page_dump(newsock, file);

	close(newsock);
/*	table[num]=0;
*/	pthread_exit(0);
	return NULL;
}

int
main(int argc, char **argv)
{
	unsigned int    socksiz;
	struct sockaddr_in srv, client;
	pthread_t **threadid;

	threadid = (void *)malloc(sizeof (void *) * 1024);
	for(socksiz=0;socksiz<=1023;socksiz++){
		threadid[socksiz] = (pthread_t *)malloc(sizeof(threadid));
		table[socksiz]=0;
	}

	if (argc != 2) {
		printf("Usage\n\t%s <port>\n", argv[0]);
		return EXIT_FAILURE;
	}
	signal(SIGTERM, terminate);
	signal(SIGKILL, terminate);
	signal(SIGINT, terminate);
	signal(SIGHUP, terminate);
	signal(SIGQUIT, terminate);
	signal(SIGPIPE, pipebomb);

	socksiz = sizeof(struct sockaddr);

	memset(&srv, 0, socksiz);
	srv.sin_family = AF_INET;
	srv.sin_port = htons(atoi(argv[1]));
	srv.sin_addr.s_addr = inet_addr("0.0.0.0");

	if ((s = socket(AF_INET, SOCK_STREAM, 0)) == (unsigned int)-1)
		oops("socket");
	if (bind(s, (struct sockaddr *) & srv, socksiz) == -1)
		oops("bind");
	if (listen(s, 5) == -1)
		oops("listen");

	while (1)
	{
		int x = 0;
		int *vals;
		int newsock = accept(s, (struct sockaddr *) & client, &socksiz);
		vals = (int *)malloc(sizeof(int) * 2);
		while(table[x]!=0)
		{
			x++;
			if(x>1023)x=0;
		}
		table[x]=1;
		vals[0] = newsock;
		vals[1] = x;
		pthread_create(
			threadid[x],
			(pthread_attr_t *)NULL,
			doserve,
			(void *)vals);
	}
	return EXIT_SUCCESS;
}
